package friend_circles

type CommentListReq struct {
	CircleIndexId string `json:"circle_index_id"` //朋友圈文档记录
	Page          int    `json:"page"`            // 页码
	PageSize      int    `json:"page_size"`       // 每页数量
}
type CommentDetailReq struct {
	CommentIndexId string `json:"comment_index_id"` //评论文档记录
	Page           int    `json:"page"`             // 页码
	PageSize       int    `json:"page_size"`        // 每页数量
}
type PublishReq struct {
	Content   string   `json:"content,required"` // 文本内容
	ImageList []string `json:"image_list"`       // 图片
	Video     string   `json:"video"`            // 视屏
}
type MySelfListReq struct {
	Page     int `json:"page"`      // 页码
	PageSize int `json:"page_size"` // 每页数量
}
type MySelfListResp struct {
	Page     int                       `json:"page"`      // 页码
	PageSize int                       `json:"page_size"` // 每页数量
	Total    int64                     `json:"total"`     // 总量
	List     []EggFriendCircleEsStruct `json:"list"`
}

type EggFriendCircleEsStruct struct {
	CircleIndexId string `json:"circle_index_id"` //朋友圈文档记录
	Uid           int64  `json:"uid" label:"uid"`
	ImUid         int64  `json:"im_uid" label:"im_uid"`
	Kind          int32  `json:"kind"  label:"类型(1:普通 2:官方)"` //类型(1:普通 2:官方)
	Content       string `json:"content" label:"文本内容"`        //文本内容
	Image         string `json:"image" label:"图片"`            //图片
	Video         string `json:"video" label:"视频"`            //视频
	LikesNums     int    `json:"likes_nums" label:"点赞数"`      //点赞数
	ShareNums     int    `json:"share_nums" label:"分享数"`      //分享数
	CommentNums   int    `json:"comment_nums" label:"评论数"`    //评论数
	IsLike        bool   `json:"is_like" label:"是否点赞"`        //是否点赞
	//State       int32  `json:"state" label:"状态(1:正常 2:隐藏)"`
	//IsTopUp     int32  `json:"is_top_up" label:"是否置顶(1:是 2:否)"`
	//IsPraise    int32  `json:"is_praise" label:"是否被表扬(1:是 2:否)"`
	CreatedAt string `json:"created_at"`
	UpdatedAt string `json:"updated_at"`
}

type CommentListResp struct {
	CircleIndexId string                           `json:"circle_index_id"`
	Total         int64                            `json:"total"` // 总评论数量
	List          []EggFriendCircleCommentEsStruct `json:"list"`
}

type CommentDetailResp struct {
	CircleIndexId string                           `json:"circle_index_id"`
	Total         int64                            `json:"total"` // 总评论数量
	List          []EggFriendCircleCommentEsStruct `json:"list"`
}

type EggFriendCircleCommentEsStruct struct {
	CommentIndexId           string `json:"comment_index_id"` //评论文档记录
	NickName                 string `json:"nickname"`
	AvatarUrl                string `json:"avatar_url"` // 用户头像
	Uid                      int64  `json:"uid" label:"uid"`
	ImUid                    int64  `json:"im_uid" label:"im_uid"`
	Kind                     int32  `json:"kind"  label:"类型(1:普通 2:官方)"` //类型(1:普通 2:官方)
	CircleId                 string `json:"circle_id" label:"朋友圈id"`     //朋友圈id
	CommentId                string `json:"comment_id" label:"评论id"`     //评论id
	CommentImUid             int64  `json:"comment_im_uid" label:"回复评论用户id"`
	ReplyCommentId           string `json:"reply_comment_id" label:"回复评论id"` //回复评论id
	ReplyCommentImUid        int64  `json:"reply_comment_im_uid" label:"回复评论用户id"`
	ReplyCommentUserNickname string `json:"reply_comment_user_nickname" label:"回复评论的用户昵称"` //回复评论的用户昵称
	Content                  string `json:"content" label:"文本内容"`                          //文本内容
	LikesNums                int    `json:"likes_nums" label:"点赞数"`                        //点赞数
	CommentNums              int    `json:"comment_nums" label:"评论数"`                      //评论数
	IsLike                   bool   `json:"is_like" label:"是否点赞"`                          //是否点赞
	//State                    int32  `json:"state" label:"状态(1:正常 2:隐藏)"`                   //状态(1:正常 2:隐藏)
	//IsPraise                 int32  `json:"is_praise" label:"是否被表扬(1:是 2:否)"`              //是否被表扬(1:是 2:否)
	CreatedAt string `json:"created_at"`
	UpdatedAt string `json:"updated_at"`
}
