package md

type SmsSendReq struct {
	Mobile        string `json:"mobile" binding:"required"`
	Type          string `json:"type" example:"h5Register:h5注册页、wechatBindPhone:微信绑定手机、login:登陆、findPwd:找回密码、changePwd:修改密码、changePasscode:修改支付密码"`
	LotNumber     string `json:"lot_number"  example:"阿里云图形验证码对应参数"`
	GenTime       string `json:"gen_time" example:"阿里云图形验证码对应参数"`
	CaptchaOutput string `json:"captcha_output" example:"阿里云图形验证码对应参数"`
	PassToken     string `json:"pass_token" example:"阿里云图形验证码对应参数"`
}
type RegisterReq struct {
	Mobile string `json:"mobile" binding:"required"`
	Code   string `json:"code"  example:"验证码"`

	Type       string `json:"type" example:"app:APP注册、h5:H5注册"`
	InviteCode string `json:"invite_code" example:"邀请码"`
	OpenID     string `json:"open_id" example:"微信openId"`
	UnionId    string `json:"union_id" example:"微信UnionId"`
	Avatar     string `json:"avatar" example:"头像"`
	Nickname   string `json:"nickname" example:"昵称"`
	Sex        int    `json:"sex"` //性别(0:未知 1:男 2:女)
	Password   string `json:"password"  example:"密码 如 123"`
}
type FindPasswordReq struct {
	Mobile   string `json:"mobile" binding:"required"`
	Code     string `json:"code"  example:"验证码"`
	Password string `json:"password"  example:"密码 如 123"`
}
type UpdatePasswordReq struct {
	Code     string `json:"code"  example:"验证码"`
	Password string `json:"password"  example:"密码 如 123"`
}
type UpdatePasscodeReq struct {
	Code     string `json:"code"  example:"验证码"`
	PassCode string `json:"passcode"  example:"密码 如 123"`
}
type WechatLoginReq struct {
	OpenID   string `json:"open_id" example:"微信openId"`
	UnionId  string `json:"union_id" example:"微信UnionId"`
	Avatar   string `json:"avatar" example:"头像"`
	Nickname string `json:"nickname" example:"昵称"`
}
type FastLoginReq struct {
	Token      string `json:"token"  example:"一键登录的token"`
	InviteCode string `json:"invite_code" example:"邀请码"`
}

type LoginReq struct {
	Phone    string `json:"phone" binding:"required" example:"手机号"`
	PassWord string `json:"password" binding:"required" example:"登录密码"`
	Code     string `json:"code"  example:"验证码"`
}

type LoginResponse struct {
	Token string `json:"token"`
}
type InviteUrl struct {
	Link       string `json:"link"`
	InviteCode string `json:"invite_code"`
	Qrcode     string `json:"qrcode"`
}
